/* Automatically generated nanopb header */
/* Generated by nanopb-0.4.7 */

#ifndef PB_SPARKPLUG_PB_H_INCLUDED
#define PB_SPARKPLUG_PB_H_INCLUDED
#include "pb.h"

#if PB_PROTO_HEADER_VERSION != 40
#error Regenerate this file with the current version of nanopb generator.
#endif

/* Enum definitions */
typedef enum _DataType {
    /* Indexes of Data Types
 Unknown placeholder for future expansion. */
    DataType_Unknown = 0,
    /* Basic Types */
    DataType_Int8 = 1,
    DataType_Int16 = 2,
    DataType_Int32 = 3,
    DataType_Int64 = 4,
    DataType_UInt8 = 5,
    DataType_UInt16 = 6,
    DataType_UInt32 = 7,
    DataType_UInt64 = 8,
    DataType_Float = 9,
    DataType_Double = 10,
    DataType_Boolean = 11,
    DataType_String = 12,
    DataType_DateTime = 13,
    DataType_Text = 14,
    /* Additional Metric Types */
    DataType_UUID = 15,
    DataType_DataSet = 16,
    DataType_Bytes = 17,
    DataType_File = 18,
    DataType_Template = 19,
    /* Additional PropertyValue Types */
    DataType_PropertySet = 20,
    DataType_PropertySetList = 21,
    /* Array Types */
    DataType_Int8Array = 22,
    DataType_Int16Array = 23,
    DataType_Int32Array = 24,
    DataType_Int64Array = 25,
    DataType_UInt8Array = 26,
    DataType_UInt16Array = 27,
    DataType_UInt32Array = 28,
    DataType_UInt64Array = 29,
    DataType_FloatArray = 30,
    DataType_DoubleArray = 31,
    DataType_BooleanArray = 32,
    DataType_StringArray = 33,
    DataType_DateTimeArray = 34
} DataType;

/* Struct definitions */
typedef struct _Payload {
    bool has_timestamp;
    uint64_t timestamp; /* Timestamp at message sending time */
    pb_callback_t metrics; /* Repeated forever - no limit in Google Protobufs */
    bool has_seq;
    uint64_t seq; /* Sequence number */
    pb_callback_t uuid; /* UUID to track message type in terms of schema definitions */
    pb_callback_t body; /* To optionally bypass the whole definition above */
    pb_extension_t *extensions;
} Payload;

typedef struct _Payload_Template {
    pb_callback_t version; /* The version of the Template to prevent mismatches */
    pb_callback_t metrics; /* Each metric includes a name, datatype, and optionally a value */
    pb_callback_t parameters;
    pb_callback_t template_ref; /* MUST be a reference to a template definition if this is an instance (i.e. the name of the template definition) - MUST be omitted for template definitions */
    bool has_is_definition;
    bool is_definition;
    pb_extension_t *extensions;
} Payload_Template;

typedef struct _Payload_Template_Parameter_ParameterValueExtension {
    pb_extension_t *extensions;
} Payload_Template_Parameter_ParameterValueExtension;

typedef struct _Payload_Template_Parameter {
    pb_callback_t name;
    bool has_type;
    uint32_t type;
    pb_size_t which_value;
    union {
        uint32_t int_value;
        uint64_t long_value;
        float float_value;
        double double_value;
        bool boolean_value;
        pb_callback_t string_value;
        Payload_Template_Parameter_ParameterValueExtension extension_value;
    } value;
} Payload_Template_Parameter;

typedef struct _Payload_DataSet {
    bool has_num_of_columns;
    uint64_t num_of_columns;
    pb_callback_t columns;
    pb_callback_t types;
    pb_callback_t rows;
    pb_extension_t *extensions;
} Payload_DataSet;

typedef struct _Payload_DataSet_DataSetValue_DataSetValueExtension {
    pb_extension_t *extensions;
} Payload_DataSet_DataSetValue_DataSetValueExtension;

typedef struct _Payload_DataSet_DataSetValue {
    pb_size_t which_value;
    union {
        uint32_t int_value;
        uint64_t long_value;
        float float_value;
        double double_value;
        bool boolean_value;
        pb_callback_t string_value;
        Payload_DataSet_DataSetValue_DataSetValueExtension extension_value;
    } value;
} Payload_DataSet_DataSetValue;

typedef struct _Payload_DataSet_Row {
    pb_callback_t elements;
    pb_extension_t *extensions;
} Payload_DataSet_Row;

typedef struct _Payload_PropertyValue_PropertyValueExtension {
    pb_extension_t *extensions;
} Payload_PropertyValue_PropertyValueExtension;

typedef struct _Payload_PropertySet {
    pb_callback_t keys; /* Names of the properties */
    pb_callback_t values;
    pb_extension_t *extensions;
} Payload_PropertySet;

typedef struct _Payload_PropertySetList {
    pb_callback_t propertyset;
    pb_extension_t *extensions;
} Payload_PropertySetList;

typedef struct _Payload_PropertyValue {
    bool has_type;
    uint32_t type;
    bool has_is_null;
    bool is_null;
    pb_size_t which_value;
    union {
        uint32_t int_value;
        uint64_t long_value;
        float float_value;
        double double_value;
        bool boolean_value;
        pb_callback_t string_value;
        Payload_PropertySet propertyset_value;
        Payload_PropertySetList propertysets_value; /* List of Property Values */
        Payload_PropertyValue_PropertyValueExtension extension_value;
    } value;
} Payload_PropertyValue;

typedef struct _Payload_MetaData {
    /* Bytes specific metadata */
    bool has_is_multi_part;
    bool is_multi_part;
    /* General metadata */
    pb_callback_t content_type; /* Content/Media type */
    bool has_size;
    uint64_t size; /* File size, String size, Multi-part size, etc */
    bool has_seq;
    uint64_t seq; /* Sequence number for multi-part messages */
    /* File metadata */
    pb_callback_t file_name; /* File name */
    pb_callback_t file_type; /* File type (i.e. xml, json, txt, cpp, etc) */
    pb_callback_t md5; /* md5 of data */
    /* Catchalls and future expansion */
    pb_callback_t description; /* Could be anything such as json or xml of custom properties */
    pb_extension_t *extensions;
} Payload_MetaData;

typedef struct _Payload_Metric_MetricValueExtension {
    pb_extension_t *extensions;
} Payload_Metric_MetricValueExtension;

typedef struct _Payload_Metric {
    pb_callback_t name; /* Metric name - should only be included on birth */
    bool has_alias;
    uint64_t alias; /* Metric alias - tied to name on birth and included in all later DATA messages */
    bool has_timestamp;
    uint64_t timestamp; /* Timestamp associated with data acquisition time */
    bool has_datatype;
    uint32_t datatype; /* DataType of the metric/tag value */
    bool has_is_historical;
    bool is_historical; /* If this is historical data and should not update real time tag */
    bool has_is_transient;
    bool is_transient; /* Tells consuming clients such as MQTT Engine to not store this as a tag */
    bool has_is_null;
    bool is_null; /* If this is null - explicitly say so rather than using -1, false, etc for some datatypes. */
    bool has_metadata;
    Payload_MetaData metadata; /* Metadata for the payload */
    bool has_properties;
    Payload_PropertySet properties;
    pb_size_t which_value;
    union {
        uint32_t int_value;
        uint64_t long_value;
        float float_value;
        double double_value;
        bool boolean_value;
        pb_callback_t string_value;
        pb_callback_t bytes_value; /* Bytes, File */
        Payload_DataSet dataset_value;
        Payload_Template template_value;
        Payload_Metric_MetricValueExtension extension_value;
    } value;
} Payload_Metric;


#ifdef __cplusplus
extern "C" {
#endif

/* Helper constants for enums */
#define _DataType_MIN DataType_UnknownPayload_Metric_init
#define _DataType_MAX DataType_DateTimeArray
#define _DataType_ARRAYSIZE ((DataType)(DataType_DateTimeArray+1))

















/* Initializer values for message structs */
#define Payload_init_default                     {false, 0, {{NULL}, NULL}, false, 0, {{NULL}, NULL}, {{NULL}, NULL}, NULL}
#define Payload_Template_init_default            {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, 0, NULL}
#define Payload_Template_Parameter_init_default  {{{NULL}, NULL}, false, 0, 0, {0}}
#define Payload_Template_Parameter_ParameterValueExtension_init_default {NULL}
#define Payload_DataSet_init_default             {false, 0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, NULL}
#define Payload_DataSet_DataSetValue_init_default {0, {0}}
#define Payload_DataSet_DataSetValue_DataSetValueExtension_init_default {NULL}
#define Payload_DataSet_Row_init_default         {{{NULL}, NULL}, NULL}
#define Payload_PropertyValue_init_default       {false, 0, false, 0, 0, {0}}
#define Payload_PropertyValue_PropertyValueExtension_init_default {NULL}
#define Payload_PropertySet_init_default         {{{NULL}, NULL}, {{NULL}, NULL}, NULL}
#define Payload_PropertySetList_init_default     {{{NULL}, NULL}, NULL}
#define Payload_MetaData_init_default            {false, 0, {{NULL}, NULL}, false, 0, false, 0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, NULL}
#define Payload_Metric_init_default              {{{NULL}, NULL}, false, 0, false, 0, false, 0, false, 0, false, 0, false, 0, false, Payload_MetaData_init_default, false, Payload_PropertySet_init_default, 0, {0}}
#define Payload_Metric_MetricValueExtension_init_default {NULL}
#define Payload_init_zero                        {false, 0, {{NULL}, NULL}, false, 0, {{NULL}, NULL}, {{NULL}, NULL}, NULL}
#define Payload_Template_init_zero               {{{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, false, 0, NULL}
#define Payload_Template_Parameter_init_zero     {{{NULL}, NULL}, false, 0, 0, {0}}
#define Payload_Template_Parameter_ParameterValueExtension_init_zero {NULL}
#define Payload_DataSet_init_zero                {false, 0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, NULL}
#define Payload_DataSet_DataSetValue_init_zero   {0, {0}}
#define Payload_DataSet_DataSetValue_DataSetValueExtension_init_zero {NULL}
#define Payload_DataSet_Row_init_zero            {{{NULL}, NULL}, NULL}
#define Payload_PropertyValue_init_zero          {false, 0, false, 0, 0, {0}}
#define Payload_PropertyValue_PropertyValueExtension_init_zero {NULL}
#define Payload_PropertySet_init_zero            {{{NULL}, NULL}, {{NULL}, NULL}, NULL}
#define Payload_PropertySetList_init_zero        {{{NULL}, NULL}, NULL}
#define Payload_MetaData_init_zero               {false, 0, {{NULL}, NULL}, false, 0, false, 0, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, {{NULL}, NULL}, NULL}
#define Payload_Metric_init_zero                 {{{NULL}, NULL}, false, 0, false, 0, false, 0, false, 0, false, 0, false, 0, false, Payload_MetaData_init_zero, false, Payload_PropertySet_init_zero, 0, {0}}
#define Payload_Metric_MetricValueExtension_init_zero {NULL}

/* Field tags (for use in manual encoding/decoding) */
#define Payload_timestamp_tag                    1
#define Payload_metrics_tag                      2
#define Payload_seq_tag                          3
#define Payload_uuid_tag                         4
#define Payload_body_tag                         5
#define Payload_Template_version_tag             1
#define Payload_Template_metrics_tag             2
#define Payload_Template_parameters_tag          3
#define Payload_Template_template_ref_tag        4
#define Payload_Template_is_definition_tag       5
#define Payload_Template_Parameter_name_tag      1
#define Payload_Template_Parameter_type_tag      2
#define Payload_Template_Parameter_int_value_tag 3
#define Payload_Template_Parameter_long_value_tag 4
#define Payload_Template_Parameter_float_value_tag 5
#define Payload_Template_Parameter_double_value_tag 6
#define Payload_Template_Parameter_boolean_value_tag 7
#define Payload_Template_Parameter_string_value_tag 8
#define Payload_Template_Parameter_extension_value_tag 9
#define Payload_DataSet_num_of_columns_tag       1
#define Payload_DataSet_columns_tag              2
#define Payload_DataSet_types_tag                3
#define Payload_DataSet_rows_tag                 4
#define Payload_DataSet_DataSetValue_int_value_tag 1
#define Payload_DataSet_DataSetValue_long_value_tag 2
#define Payload_DataSet_DataSetValue_float_value_tag 3
#define Payload_DataSet_DataSetValue_double_value_tag 4
#define Payload_DataSet_DataSetValue_boolean_value_tag 5
#define Payload_DataSet_DataSetValue_string_value_tag 6
#define Payload_DataSet_DataSetValue_extension_value_tag 7
#define Payload_DataSet_Row_elements_tag         1
#define Payload_PropertySet_keys_tag             1
#define Payload_PropertySet_values_tag           2
#define Payload_PropertySetList_propertyset_tag  1
#define Payload_PropertyValue_type_tag           1
#define Payload_PropertyValue_is_null_tag        2
#define Payload_PropertyValue_int_value_tag      3
#define Payload_PropertyValue_long_value_tag     4
#define Payload_PropertyValue_float_value_tag    5
#define Payload_PropertyValue_double_value_tag   6
#define Payload_PropertyValue_boolean_value_tag  7
#define Payload_PropertyValue_string_value_tag   8
#define Payload_PropertyValue_propertyset_value_tag 9
#define Payload_PropertyValue_propertysets_value_tag 10
#define Payload_PropertyValue_extension_value_tag 11
#define Payload_MetaData_is_multi_part_tag       1
#define Payload_MetaData_content_type_tag        2
#define Payload_MetaData_size_tag                3
#define Payload_MetaData_seq_tag                 4
#define Payload_MetaData_file_name_tag           5
#define Payload_MetaData_file_type_tag           6
#define Payload_MetaData_md5_tag                 7
#define Payload_MetaData_description_tag         8
#define Payload_Metric_name_tag                  1
#define Payload_Metric_alias_tag                 2
#define Payload_Metric_timestamp_tag             3
#define Payload_Metric_datatype_tag              4
#define Payload_Metric_is_historical_tag         5
#define Payload_Metric_is_transient_tag          6
#define Payload_Metric_is_null_tag               7
#define Payload_Metric_metadata_tag              8
#define Payload_Metric_properties_tag            9
#define Payload_Metric_int_value_tag             10
#define Payload_Metric_long_value_tag            11
#define Payload_Metric_float_value_tag           12
#define Payload_Metric_double_value_tag          13
#define Payload_Metric_boolean_value_tag         14
#define Payload_Metric_string_value_tag          15
#define Payload_Metric_bytes_value_tag           16
#define Payload_Metric_dataset_value_tag         17
#define Payload_Metric_template_value_tag        18
#define Payload_Metric_extension_value_tag       19

/* Struct field encoding specification for nanopb */
#define Payload_FIELDLIST(X, a) \
X(a, STATIC,   OPTIONAL, UINT64,   timestamp,         1) \
X(a, CALLBACK, REPEATED, MESSAGE,  metrics,           2) \
X(a, STATIC,   OPTIONAL, UINT64,   seq,               3) \
X(a, CALLBACK, OPTIONAL, STRING,   uuid,              4) \
X(a, CALLBACK, OPTIONAL, BYTES,    body,              5) \
X(a, CALLBACK, OPTIONAL, EXTENSION, extensions,        6)
#define Payload_CALLBACK pb_default_field_callback
#define Payload_DEFAULT NULL
#define Payload_metrics_MSGTYPE Payload_Metric

#define Payload_Template_FIELDLIST(X, a) \
X(a, CALLBACK, OPTIONAL, STRING,   version,           1) \
X(a, CALLBACK, REPEATED, MESSAGE,  metrics,           2) \
X(a, CALLBACK, REPEATED, MESSAGE,  parameters,        3) \
X(a, CALLBACK, OPTIONAL, STRING,   template_ref,      4) \
X(a, STATIC,   OPTIONAL, BOOL,     is_definition,     5) \
X(a, CALLBACK, OPTIONAL, EXTENSION, extensions,        6)
#define Payload_Template_CALLBACK pb_default_field_callback
#define Payload_Template_DEFAULT NULL
#define Payload_Template_metrics_MSGTYPE Payload_Metric
#define Payload_Template_parameters_MSGTYPE Payload_Template_Parameter

#define Payload_Template_Parameter_FIELDLIST(X, a) \
X(a, CALLBACK, OPTIONAL, STRING,   name,              1) \
X(a, STATIC,   OPTIONAL, UINT32,   type,              2) \
X(a, STATIC,   ONEOF,    UINT32,   (value,int_value,value.int_value),   3) \
X(a, STATIC,   ONEOF,    UINT64,   (value,long_value,value.long_value),   4) \
X(a, STATIC,   ONEOF,    FLOAT,    (value,float_value,value.float_value),   5) \
X(a, STATIC,   ONEOF,    DOUBLE,   (value,double_value,value.double_value),   6) \
X(a, STATIC,   ONEOF,    BOOL,     (value,boolean_value,value.boolean_value),   7) \
X(a, CALLBACK, ONEOF,    STRING,   (value,string_value,value.string_value),   8) \
X(a, STATIC,   ONEOF,    MESSAGE,  (value,extension_value,value.extension_value),   9)
#define Payload_Template_Parameter_CALLBACK pb_default_field_callback
#define Payload_Template_Parameter_DEFAULT NULL
#define Payload_Template_Parameter_value_extension_value_MSGTYPE Payload_Template_Parameter_ParameterValueExtension

#define Payload_Template_Parameter_ParameterValueExtension_FIELDLIST(X, a) \
X(a, CALLBACK, OPTIONAL, EXTENSION, extensions,        1)
#define Payload_Template_Parameter_ParameterValueExtension_CALLBACK pb_default_field_callback
#define Payload_Template_Parameter_ParameterValueExtension_DEFAULT NULL

#define Payload_DataSet_FIELDLIST(X, a) \
X(a, STATIC,   OPTIONAL, UINT64,   num_of_columns,    1) \
X(a, CALLBACK, REPEATED, STRING,   columns,           2) \
X(a, CALLBACK, REPEATED, UINT32,   types,             3) \
X(a, CALLBACK, REPEATED, MESSAGE,  rows,              4) \
X(a, CALLBACK, OPTIONAL, EXTENSION, extensions,        5)
#define Payload_DataSet_CALLBACK pb_default_field_callback
#define Payload_DataSet_DEFAULT NULL
#define Payload_DataSet_rows_MSGTYPE Payload_DataSet_Row

#define Payload_DataSet_DataSetValue_FIELDLIST(X, a) \
X(a, STATIC,   ONEOF,    UINT32,   (value,int_value,value.int_value),   1) \
X(a, STATIC,   ONEOF,    UINT64,   (value,long_value,value.long_value),   2) \
X(a, STATIC,   ONEOF,    FLOAT,    (value,float_value,value.float_value),   3) \
X(a, STATIC,   ONEOF,    DOUBLE,   (value,double_value,value.double_value),   4) \
X(a, STATIC,   ONEOF,    BOOL,     (value,boolean_value,value.boolean_value),   5) \
X(a, CALLBACK, ONEOF,    STRING,   (value,string_value,value.string_value),   6) \
X(a, STATIC,   ONEOF,    MESSAGE,  (value,extension_value,value.extension_value),   7)
#define Payload_DataSet_DataSetValue_CALLBACK pb_default_field_callback
#define Payload_DataSet_DataSetValue_DEFAULT NULL
#define Payload_DataSet_DataSetValue_value_extension_value_MSGTYPE Payload_DataSet_DataSetValue_DataSetValueExtension

#define Payload_DataSet_DataSetValue_DataSetValueExtension_FIELDLIST(X, a) \
X(a, CALLBACK, OPTIONAL, EXTENSION, extensions,        1)
#define Payload_DataSet_DataSetValue_DataSetValueExtension_CALLBACK pb_default_field_callback
#define Payload_DataSet_DataSetValue_DataSetValueExtension_DEFAULT NULL

#define Payload_DataSet_Row_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, MESSAGE,  elements,          1) \
X(a, CALLBACK, OPTIONAL, EXTENSION, extensions,        2)
#define Payload_DataSet_Row_CALLBACK pb_default_field_callback
#define Payload_DataSet_Row_DEFAULT NULL
#define Payload_DataSet_Row_elements_MSGTYPE Payload_DataSet_DataSetValue

#define Payload_PropertyValue_FIELDLIST(X, a) \
X(a, STATIC,   OPTIONAL, UINT32,   type,              1) \
X(a, STATIC,   OPTIONAL, BOOL,     is_null,           2) \
X(a, STATIC,   ONEOF,    UINT32,   (value,int_value,value.int_value),   3) \
X(a, STATIC,   ONEOF,    UINT64,   (value,long_value,value.long_value),   4) \
X(a, STATIC,   ONEOF,    FLOAT,    (value,float_value,value.float_value),   5) \
X(a, STATIC,   ONEOF,    DOUBLE,   (value,double_value,value.double_value),   6) \
X(a, STATIC,   ONEOF,    BOOL,     (value,boolean_value,value.boolean_value),   7) \
X(a, CALLBACK, ONEOF,    STRING,   (value,string_value,value.string_value),   8) \
X(a, STATIC,   ONEOF,    MESSAGE,  (value,propertyset_value,value.propertyset_value),   9) \
X(a, STATIC,   ONEOF,    MESSAGE,  (value,propertysets_value,value.propertysets_value),  10) \
X(a, STATIC,   ONEOF,    MESSAGE,  (value,extension_value,value.extension_value),  11)
#define Payload_PropertyValue_CALLBACK pb_default_field_callback
#define Payload_PropertyValue_DEFAULT NULL
#define Payload_PropertyValue_value_propertyset_value_MSGTYPE Payload_PropertySet
#define Payload_PropertyValue_value_propertysets_value_MSGTYPE Payload_PropertySetList
#define Payload_PropertyValue_value_extension_value_MSGTYPE Payload_PropertyValue_PropertyValueExtension

#define Payload_PropertyValue_PropertyValueExtension_FIELDLIST(X, a) \
X(a, CALLBACK, OPTIONAL, EXTENSION, extensions,        1)
#define Payload_PropertyValue_PropertyValueExtension_CALLBACK pb_default_field_callback
#define Payload_PropertyValue_PropertyValueExtension_DEFAULT NULL

#define Payload_PropertySet_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, STRING,   keys,              1) \
X(a, CALLBACK, REPEATED, MESSAGE,  values,            2) \
X(a, CALLBACK, OPTIONAL, EXTENSION, extensions,        3)
#define Payload_PropertySet_CALLBACK pb_default_field_callback
#define Payload_PropertySet_DEFAULT NULL
#define Payload_PropertySet_values_MSGTYPE Payload_PropertyValue

#define Payload_PropertySetList_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, MESSAGE,  propertyset,       1) \
X(a, CALLBACK, OPTIONAL, EXTENSION, extensions,        2)
#define Payload_PropertySetList_CALLBACK pb_default_field_callback
#define Payload_PropertySetList_DEFAULT NULL
#define Payload_PropertySetList_propertyset_MSGTYPE Payload_PropertySet

#define Payload_MetaData_FIELDLIST(X, a) \
X(a, STATIC,   OPTIONAL, BOOL,     is_multi_part,     1) \
X(a, CALLBACK, OPTIONAL, STRING,   content_type,      2) \
X(a, STATIC,   OPTIONAL, UINT64,   size,              3) \
X(a, STATIC,   OPTIONAL, UINT64,   seq,               4) \
X(a, CALLBACK, OPTIONAL, STRING,   file_name,         5) \
X(a, CALLBACK, OPTIONAL, STRING,   file_type,         6) \
X(a, CALLBACK, OPTIONAL, STRING,   md5,               7) \
X(a, CALLBACK, OPTIONAL, STRING,   description,       8) \
X(a, CALLBACK, OPTIONAL, EXTENSION, extensions,        9)
#define Payload_MetaData_CALLBACK pb_default_field_callback
#define Payload_MetaData_DEFAULT NULL

#define Payload_Metric_FIELDLIST(X, a) \
X(a, CALLBACK, OPTIONAL, STRING,   name,              1) \
X(a, STATIC,   OPTIONAL, UINT64,   alias,             2) \
X(a, STATIC,   OPTIONAL, UINT64,   timestamp,         3) \
X(a, STATIC,   OPTIONAL, UINT32,   datatype,          4) \
X(a, STATIC,   OPTIONAL, BOOL,     is_historical,     5) \
X(a, STATIC,   OPTIONAL, BOOL,     is_transient,      6) \
X(a, STATIC,   OPTIONAL, BOOL,     is_null,           7) \
X(a, STATIC,   OPTIONAL, MESSAGE,  metadata,          8) \
X(a, STATIC,   OPTIONAL, MESSAGE,  properties,        9) \
X(a, STATIC,   ONEOF,    UINT32,   (value,int_value,value.int_value),  10) \
X(a, STATIC,   ONEOF,    UINT64,   (value,long_value,value.long_value),  11) \
X(a, STATIC,   ONEOF,    FLOAT,    (value,float_value,value.float_value),  12) \
X(a, STATIC,   ONEOF,    DOUBLE,   (value,double_value,value.double_value),  13) \
X(a, STATIC,   ONEOF,    BOOL,     (value,boolean_value,value.boolean_value),  14) \
X(a, CALLBACK, ONEOF,    STRING,   (value,string_value,value.string_value),  15) \
X(a, CALLBACK, ONEOF,    BYTES,    (value,bytes_value,value.bytes_value),  16) \
X(a, STATIC,   ONEOF,    MESSAGE,  (value,dataset_value,value.dataset_value),  17) \
X(a, STATIC,   ONEOF,    MESSAGE,  (value,template_value,value.template_value),  18) \
X(a, STATIC,   ONEOF,    MESSAGE,  (value,extension_value,value.extension_value),  19)
#define Payload_Metric_CALLBACK pb_default_field_callback
#define Payload_Metric_DEFAULT NULL
#define Payload_Metric_metadata_MSGTYPE Payload_MetaData
#define Payload_Metric_properties_MSGTYPE Payload_PropertySet
#define Payload_Metric_value_dataset_value_MSGTYPE Payload_DataSet
#define Payload_Metric_value_template_value_MSGTYPE Payload_Template
#define Payload_Metric_value_extension_value_MSGTYPE Payload_Metric_MetricValueExtension

#define Payload_Metric_MetricValueExtension_FIELDLIST(X, a) \
X(a, CALLBACK, OPTIONAL, EXTENSION, extensions,        1)
#define Payload_Metric_MetricValueExtension_CALLBACK pb_default_field_callback
#define Payload_Metric_MetricValueExtension_DEFAULT NULL

extern const pb_msgdesc_t Payload_msg;
extern const pb_msgdesc_t Payload_Template_msg;
extern const pb_msgdesc_t Payload_Template_Parameter_msg;
extern const pb_msgdesc_t Payload_Template_Parameter_ParameterValueExtension_msg;
extern const pb_msgdesc_t Payload_DataSet_msg;
extern const pb_msgdesc_t Payload_DataSet_DataSetValue_msg;
extern const pb_msgdesc_t Payload_DataSet_DataSetValue_DataSetValueExtension_msg;
extern const pb_msgdesc_t Payload_DataSet_Row_msg;
extern const pb_msgdesc_t Payload_PropertyValue_msg;
extern const pb_msgdesc_t Payload_PropertyValue_PropertyValueExtension_msg;
extern const pb_msgdesc_t Payload_PropertySet_msg;
extern const pb_msgdesc_t Payload_PropertySetList_msg;
extern const pb_msgdesc_t Payload_MetaData_msg;
extern const pb_msgdesc_t Payload_Metric_msg;
extern const pb_msgdesc_t Payload_Metric_MetricValueExtension_msg;

/* Defines for backwards compatibility with code written before nanopb-0.4.0 */
#define Payload_fields &Payload_msg
#define Payload_Template_fields &Payload_Template_msg
#define Payload_Template_Parameter_fields &Payload_Template_Parameter_msg
#define Payload_Template_Parameter_ParameterValueExtension_fields &Payload_Template_Parameter_ParameterValueExtension_msg
#define Payload_DataSet_fields &Payload_DataSet_msg
#define Payload_DataSet_DataSetValue_fields &Payload_DataSet_DataSetValue_msg
#define Payload_DataSet_DataSetValue_DataSetValueExtension_fields &Payload_DataSet_DataSetValue_DataSetValueExtension_msg
#define Payload_DataSet_Row_fields &Payload_DataSet_Row_msg
#define Payload_PropertyValue_fields &Payload_PropertyValue_msg
#define Payload_PropertyValue_PropertyValueExtension_fields &Payload_PropertyValue_PropertyValueExtension_msg
#define Payload_PropertySet_fields &Payload_PropertySet_msg
#define Payload_PropertySetList_fields &Payload_PropertySetList_msg
#define Payload_MetaData_fields &Payload_MetaData_msg
#define Payload_Metric_fields &Payload_Metric_msg
#define Payload_Metric_MetricValueExtension_fields &Payload_Metric_MetricValueExtension_msg

/* Maximum encoded size of messages (where known) */
/* Payload_size depends on runtime parameters */
/* Payload_Template_size depends on runtime parameters */
/* Payload_Template_Parameter_size depends on runtime parameters */
/* Payload_DataSet_size depends on runtime parameters */
/* Payload_DataSet_DataSetValue_size depends on runtime parameters */
/* Payload_DataSet_Row_size depends on runtime parameters */
/* Payload_PropertyValue_size depends on runtime parameters */
/* Payload_PropertySet_size depends on runtime parameters */
/* Payload_PropertySetList_size depends on runtime parameters */
/* Payload_MetaData_size depends on runtime parameters */
/* Payload_Metric_size depends on runtime parameters */
#define Payload_DataSet_DataSetValue_DataSetValueExtension_size 0
#define Payload_Metric_MetricValueExtension_size 0
#define Payload_PropertyValue_PropertyValueExtension_size 0
#define Payload_Template_Parameter_ParameterValueExtension_size 0

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
